

<!DOCTYPE html>
<html lang="en">

<head>
  
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title> utils/utils.tsx</title>

  <script src="https://cdn.jsdelivr.net/gh/google/code-prettify@master/loader/run_prettify.js"></script>
  <script src="https://unpkg.com/@babel/standalone/babel.min.js"></script>
  <script src="./build/entry.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <!--[if lt IE 9]>
    <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
  <![endif]-->
  <link href="https://fonts.googleapis.com/css?family=Roboto:100,400,700|Inconsolata,700" rel="stylesheet">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.3/css/all.css" integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/" crossorigin="anonymous">
  <link type="text/css" rel="stylesheet" href="https://jmblog.github.io/color-themes-for-google-code-prettify/themes/tomorrow-night.min.css">
  <link type="text/css" rel="stylesheet" href="styles/app.min.css">
  <link type="text/css" rel="stylesheet" href="styles/iframe.css">
  <link type="text/css" rel="stylesheet" href="">
  <script async defer src="https://buttons.github.io/buttons.js"></script>

  
</head>



<body class="layout small-header">
    <div id="stickyNavbarOverlay"></div>
    

<div class="top-nav">
    <div class="inner">
        <a id="hamburger" role="button" class="navbar-burger" aria-label="menu" aria-expanded="false">
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
        </a>
        <div class="logo">
            
            
        </div>
        <div class="menu">
            
            <div class="navigation">
                <a
                    href="index.html"
                    class="link"
                >
                    API Documentation
                </a>
                
                
                
            </div>
        </div>
    </div>
</div>
    <div id="main">
        <div
            class="sidebar "
            id="sidebarNav"
        >
            
            <nav>
                
                    <h2><a href="index.html">Documentation</a></h2><div class="category"><h3>Global</h3><ul><li><a href="global.html#loadMSData">loadMSData</a></li><li><a href="global.html#params">params</a></li><li><a href="global.html#ProfileData">ProfileData</a></li><li><a href="global.html#SignInButton">SignInButton</a></li></ul></div>
                
            </nav>
        </div>
        <div class="core" id="main-content-wrapper">
            <div class="content">
                <header class="page-title">
                    <p>Source</p>
                    <h1>utils/utils.tsx</h1>
                </header>
                



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import { loginRequest } from '../config/authConfig';
import { graphConfig } from '../config/authConfig';

/**
 * A wrapper for calling MS Graph with Auth Token
 * @function
 * @template A
 * @param {Object} instance
 * @param {Object} accounts
 * @param {Object} params
 * @returns {Promise&lt;A>}
 */
export async function loadMSData(instance: any, accounts: any, { url, method } = {} as any) {
  // const { instance, accounts } = useMsal();
  try {
    const accessToken = localStorage.getItem('token');
    if (!accessToken) {
      await setupAccessToken(instance, accounts);
    }
    const resp = await callMsGraph({ url, method });
    if (Object.prototype.hasOwnProperty.call(resp, 'error')) {
      throw Error;
    }
    return resp;
  } catch (e) {
    const request = { ...loginRequest, account: accounts[0] };
    await instance.acquireTokenPopup(request);
    await setupAccessToken(instance, accounts);
    return await callMsGraph({ url, method });
  }
}

// Silently acquires an access token which is then attached to a request for Microsoft Graph data
async function setupAccessToken(instance: any, accounts: any) {
  const request = {
    ...loginRequest,
    account: accounts[0]
  };
  const response = await instance.acquireTokenSilent(request);
  localStorage.setItem('token', response.accessToken);
}

/**
 * Attaches a given access token to a Microsoft Graph API call. Returns information about the user
 */
const params = {
  url: graphConfig.graphMeEndpoint,
  method: 'GET'
};

export async function callMsGraph({ url, method } = params) {
  const accessToken = localStorage.getItem('token');
  const headers = new Headers();
  const bearer = `Bearer ${accessToken}`;
  headers.append('Authorization', bearer);

  const options = {
    method: method,
    headers: headers
  };

  try {
    const response = await fetch(url, options);
    const data = await response.json();
    return data;
  } catch (error) {
    console.log(error);
  }
}
</code></pre>
        </article>
    </section>




            </div>
            
            <footer class="footer">
                <div class="content has-text-centered">
                    <p>Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.7</a></p>
                    <p class="sidebar-created-by">
                        <a href="https://github.com/SoftwareBrothers/better-docs" target="_blank">BetterDocs theme</a> provided with <i class="fas fa-heart"></i> by 
                        <a href="http://softwarebrothers.co" target="_blank">SoftwareBrothers - JavaScript Development Agency</a>
                    </p>
                </div>
            </footer>
            
        </div>
        <div id="side-nav" class="side-nav">
        </div>
    </div>
<script src="scripts/app.min.js"></script>
<script>PR.prettyPrint();</script>
<script src="scripts/linenumber.js"> </script>

</body>
</html>
